/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.57 from the
 * contents of LZO.xs. Do not edit this file, edit LZO.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LZO.xs"
/* LZO.xs -- Perl bindings for the LZO data compression library

   This file is part of the LZO real-time data compression library.

   Copyright (C) 2002 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 2001 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 2000 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 1999 Markus Franz Xaver Johannes Oberhumer
   Copyright (C) 1998 Markus Franz Xaver Johannes Oberhumer
   All Rights Reserved.

   The LZO library is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License, or (at your option) any later version.

   The LZO library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with the LZO library; see the file COPYING.
   If not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   Markus F.X.J. Oberhumer
   <markus@oberhumer.com>
   http://www.oberhumer.com/opensource/lzo/
 */


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <lzo/lzoconf.h>
#include <lzo/lzo1x.h>

#if !defined(LZO_VERSION) || (LZO_VERSION < 0x1070)
#  error "Need LZO v1.07 or newer"
#endif

#undef UNUSED
#define UNUSED(x)       ((void)&x)


/* If the buffer is a reference, dereference it */
static SV *deRef(SV *sv, const char *method)
{
	SV *last_sv = NULL;
	while (SvROK(sv) && sv != last_sv)
	{
		last_sv = sv;
		sv = SvRV(sv);
	}
	if (!SvOK(sv))
		croak("Compress::LZO::%s: buffer parameter is not a SCALAR", method);
	return sv;
}


static double constant(const char *name, int arg)
{
    UNUSED(name);
    UNUSED(arg);
	errno = EINVAL;
	return 0;
}


/***********************************************************************
// XSUB start
************************************************************************/

#line 86 "LZO.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

/* simple backcompat versions of the TARGx() macros with no optimisation */
#ifndef TARGi
#  define TARGi(iv, do_taint) sv_setiv_mg(TARG, iv)
#  define TARGu(uv, do_taint) sv_setuv_mg(TARG, uv)
#  define TARGn(nv, do_taint) sv_setnv_mg(TARG, nv)
#endif

#line 237 "LZO.c"
#define X_LZO_VERSION()         lzo_version()

XS_EUPXS(XS_Compress__LZO_LZO_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_LZO_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION();
	TARGu((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}

#define X_LZO_VERSION_STRING()  (const char *)lzo_version_string()

XS_EUPXS(XS_Compress__LZO_LZO_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_LZO_VERSION_STRING)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION_STRING();
	sv_setpv((SV*)TARG, RETVAL);
	ST(0) = TARG;
    }
    XSRETURN(1);
}

#define X_LZO_VERSION_DATE()    (const char *)lzo_version_date()

XS_EUPXS(XS_Compress__LZO_LZO_VERSION_DATE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_LZO_VERSION_DATE)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = X_LZO_VERSION_DATE();
	sv_setpv((SV*)TARG, RETVAL);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	const char *	name = (const char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	TARGn((double)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_compress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_compress)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, level = 1");
    {
#line 111 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		int        level = 1;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_voidp  wrkmem;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 336 "LZO.c"
	SV *	RETVAL;
#line 122 "LZO.xs"
		sv = deRef(ST(0), "compress");
		in = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			level = SvIV(ST(1));
		in_len = len;
		out_len = in_len + in_len / 64 + 16 + 3;
		RETVAL = newSV(5+out_len);
		SvPOK_only(RETVAL);
		if (level == 1)
			wrkmem = safemalloc(LZO1X_1_MEM_COMPRESS);
		else
			wrkmem = safemalloc(LZO1X_999_MEM_COMPRESS);
		out = SvPVX(RETVAL);
		new_len = out_len;
		if (level == 1)	{
			out[0] = 0xf0;
			err = lzo1x_1_compress(in,in_len,out+5,&new_len,wrkmem);
		} else {
			out[0] = 0xf1;
			err = lzo1x_999_compress(in,in_len,out+5,&new_len,wrkmem);
		}
		safefree(wrkmem);
		if (err != LZO_E_OK || new_len > out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		SvCUR_set(RETVAL,5+new_len);
		out[1] = (in_len >> 24) & 0xff;
		out[2] = (in_len >> 16) & 0xff;
		out[3] = (in_len >>  8) & 0xff;
		out[4] = (in_len >>  0) & 0xff;
#line 371 "LZO.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_decompress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_decompress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string");
    {
#line 165 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 395 "LZO.c"
	SV *	RETVAL;
#line 174 "LZO.xs"
		sv = deRef(ST(0), "decompress");
		in = (lzo_bytep) SvPV(sv, len);
		if (len < 5 + 3 || in[0] < 0xf0 || in[0] > 0xf1)
			XSRETURN_UNDEF;
		in_len = len - 5;
		out_len = (in[1] << 24) | (in[2] << 16) | (in[3] << 8) | in[4];
		RETVAL = newSV(out_len > 0 ? out_len : 1);
		SvPOK_only(RETVAL);
		out = SvPVX(RETVAL);
		new_len = out_len;
		err = lzo1x_decompress_safe(in+5,in_len,out,&new_len,NULL);
		if (err != LZO_E_OK || new_len != out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		SvCUR_set(RETVAL, new_len);
#line 415 "LZO.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_optimize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_optimize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string");
    {
#line 202 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  in;
		lzo_bytep  out;
		lzo_uint   in_len;
		lzo_uint   out_len;
		lzo_uint   new_len;
		int        err;
#line 439 "LZO.c"
	SV *	RETVAL;
#line 211 "LZO.xs"
		sv = deRef(ST(0), "optimize");
		RETVAL = newSVsv(sv);
		SvPOK_only(RETVAL);
		in = (lzo_bytep) SvPV(RETVAL, len);
		if (len < 5 + 3 || in[0] < 0xf0 || in[0] > 0xf1)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
		in_len = len - 5;
		out_len = (in[1] << 24) | (in[2] << 16) | (in[3] << 8) | in[4];
		out = (lzo_bytep) safemalloc(out_len > 0 ? out_len : 1);
		new_len = out_len;
		err = lzo1x_optimize(in+5,in_len,out,&new_len,NULL);
		safefree(out);
		if (err != LZO_E_OK || new_len != out_len)
		{
			SvREFCNT_dec(RETVAL);
			XSRETURN_UNDEF;
		}
#line 462 "LZO.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_adler32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_adler32)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, adler = adlerInitial");
    {
#line 242 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  buf;
#line 481 "LZO.c"
	lzo_uint32	RETVAL;
	dXSTARG;
#line 246 "LZO.xs"
		sv = deRef(ST(0), "adler32");
		buf = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			RETVAL = SvUV(ST(1));
		else
			RETVAL = 1;
		RETVAL = lzo_adler32(RETVAL, buf, (lzo_uint)len);
#line 492 "LZO.c"
	TARGu((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Compress__LZO_crc32); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Compress__LZO_crc32)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "string, crc = crcInitial");
    {
#line 260 "LZO.xs"
		SV *       sv;
		STRLEN     len;
		lzo_bytep  buf;
#line 511 "LZO.c"
	lzo_uint32	RETVAL;
	dXSTARG;
#line 264 "LZO.xs"
		sv = deRef(ST(0), "crc32");
		buf = (lzo_bytep) SvPV(sv, len);
		if (items == 2 && SvOK(ST(1)))
			RETVAL = SvUV(ST(1));
		else
			RETVAL = 0;
		RETVAL = lzo_crc32(RETVAL, buf, (lzo_uint)len);
#line 522 "LZO.c"
	TARGu((IV)RETVAL, 1);
	ST(0) = TARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Compress__LZO); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Compress__LZO)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Compress::LZO::LZO_VERSION", XS_Compress__LZO_LZO_VERSION, file, "");
        (void)newXSproto_portable("Compress::LZO::LZO_VERSION_STRING", XS_Compress__LZO_LZO_VERSION_STRING, file, "");
        (void)newXSproto_portable("Compress::LZO::LZO_VERSION_DATE", XS_Compress__LZO_LZO_VERSION_DATE, file, "");
        (void)newXSproto_portable("Compress::LZO::constant", XS_Compress__LZO_constant, file, "$$");
        (void)newXSproto_portable("Compress::LZO::compress", XS_Compress__LZO_compress, file, "$;$");
        (void)newXSproto_portable("Compress::LZO::decompress", XS_Compress__LZO_decompress, file, "$");
        (void)newXSproto_portable("Compress::LZO::optimize", XS_Compress__LZO_optimize, file, "$");
        (void)newXSproto_portable("Compress::LZO::adler32", XS_Compress__LZO_adler32, file, "$;$");
        (void)newXSproto_portable("Compress::LZO::crc32", XS_Compress__LZO_crc32, file, "$;$");

    /* Initialisation Section */

#line 82 "LZO.xs"
	if (lzo_init() != LZO_E_OK)
		croak("Compress::LZO lzo_init() failed\n");

#line 573 "LZO.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
